% parametri, SI jedinice osim energije (eV)
g=-0.5*1i;
e=0.5;
zplus=1i*1e-12;
E=linspace(-4,4,1000);
Np=2; % dimenzija hamiltonijana
t0=0; % interakcija izmedju dva stanja

% konstrukcija hamiltonijana
H=-t0*diag(ones(1,Np-1),1)-t0*diag(ones(1,Np-1),-1);
H(1,1)=e; H(2,2)=-e;
% matrica vl. en. kontakta
L=diag(ones(1,Np));
sig1=g*L;

D1=zeros(1,length(E));
D2=zeros(1,length(E));

for n=1:length(E)
    
    EE=E(n);
    G=inv(((EE+zplus)*eye(Np))-H-sig1);

    A=1i*(G-G');
    D1(n)=A(1,1);
    D2(n)=A(2,2);
        
end

figure(1), plot(D1,E,'b-',D2,E,'r--','LineWidth',2), grid on, ylim([-4 4]),...
    xlim([0 4]), legend('A(1,1)','A(2,2)'), ylabel('E (eV)'),...
    xlabel('A(E)  (eV^{-1})'), title('t = 0 eV');
