% parametri, SI jedinice osim energije (eV)
H=0.5; % orbitalna energija
zplus=1i*1e-12;
E=linspace(-4,4,1000);

% matrice vl. energ. kontakata
g1=0.5-0.5*1i;
g2=0.1-0.1*1i;
sigL1=g1; sigR1=g1;
sigL2=g2; sigR2=g2;
sigL3=g1; sigR3=g2;

A1=zeros(1,length(E));
A2=zeros(1,length(E));
A3=zeros(1,length(E));
TM1=zeros(1,length(E));
TM2=zeros(1,length(E));
TM3=zeros(1,length(E));

for n=1:length(E)
    
    EE=E(n);
    % matrice prosirenja    
    gamL1=1i*(sigL1-sigL1'); gamR1=1i*(sigR1-sigR1');
    gamL2=1i*(sigL2-sigL2'); gamR2=1i*(sigR2-sigR2');
    gamL3=1i*(sigL3-sigL3'); gamR3=1i*(sigR3-sigR3');
    % Greenove funkcije
    G1=inv((EE+zplus)-H-sigL1-sigR1);
    G2=inv((EE+zplus)-H-sigL2-sigR2);
    G3=inv((EE+zplus)-H-sigL3-sigR3);
    % spektralne funkcije
    A1(n)=trace(1i*(G1-G1'));
    A2(n)=trace(1i*(G2-G2'));
    A3(n)=trace(1i*(G3-G3'));
    % transmisija    
    TM1(n)=real(trace(gamL1*G1*gamR1*G1'));
    TM2(n)=real(trace(gamL2*G2*gamR2*G2'));
    TM3(n)=real(trace(gamL3*G3*gamR3*G3'));
    
end

figure(1), ...
    subplot(1,2,1), plot(A1,E,'b-',A2,E,'r--',A3,E,'k:','LineWidth',2), ...
        grid on, ylim([-4 4]), xlim([0 10]), ...
        legend(['\Sigma_{L,R} = 0,5 - 0,5*i'],['\Sigma_{L,R} = 0,1 - 0,1*i'],...
        ['\Sigma_{L,R} = asimetricno'],'Location','southeast'),...
        ylabel('E (eV)'), xlabel('A(E) (eV^{-1})')
    subplot(1,2,2), plot(TM1,E,'b-',TM2,E,'r--',TM3,E,'k:','LineWidth',2), ...
        grid on, ylim([-4 4]), xlim([0 1.2]), ...
        legend(['\Sigma_{L,R} = 0,5 - 0,5*i'],['\Sigma_{L,R} = 0,1 - 0,1*i'],...
        ['\Sigma_{L,R} = asimetricno'],'Location','southeast'),...
        ylabel('E (eV)'), xlabel('T(E)')
