% parametri, SI jedinice osim energije (eV)
t0=0; t1=1;
Gamma=0.5; g=-1i*Gamma/2;
e1=0.5; e2=-0.5;
zplus=1i*1e-12;
E=linspace(-4,4,1000);
Np=2; % dimenzija hamiltonijana

% matrice hamiltonijana
H0=-t0*diag(ones(1,Np-1),1)-t0*diag(ones(1,Np-1),-1);
H0(1,1)=e1; H0(2,2)=e2;
H1=-t1*diag(ones(1,Np-1),1)-t1*diag(ones(1,Np-1),-1);
H1(1,1)=e1; H1(2,2)=e2;

% matrice vl. en. kontakata
sigL1 = [g 0; 0 g]; sigL2 = [g 0; 0 0]; sigL3 = [g 0; 0 0];
sigR1 = [g 0; 0 g]; sigR2 = [g 0; 0 0]; sigR3 = [0 0; 0 g];
% matrice prosirenja
gamL1=1i*(sigL1-sigL1'); gamR1=1i*(sigR1-sigR1');
gamL2=1i*(sigL2-sigL2'); gamR2=1i*(sigR2-sigR2');
gamL3=1i*(sigL3-sigL3'); gamR3=1i*(sigR3-sigR3');

for n=1:length(E)
    
    EE=E(n);
    
    G10=inv(((EE+zplus)*eye(Np))-H0-sigL1-sigR1);
    G20=inv(((EE+zplus)*eye(Np))-H0-sigL2-sigR2);
    G30=inv(((EE+zplus)*eye(Np))-H0-sigL3-sigR3);

    G11=inv(((EE+zplus)*eye(Np))-H1-sigL1-sigR1);
    G21=inv(((EE+zplus)*eye(Np))-H1-sigL2-sigR2);
    G31=inv(((EE+zplus)*eye(Np))-H1-sigL3-sigR3);
        
    TM10(n)=real(trace(gamL1*G10*gamR1*G10'));
    TM20(n)=real(trace(gamL2*G20*gamR2*G20'));
    TM30(n)=real(trace(gamL3*G30*gamR3*G30'));
    
    TM11(n)=real(trace(gamL1*G11*gamR1*G11'));
    TM21(n)=real(trace(gamL2*G21*gamR2*G21'));
    TM31(n)=real(trace(gamL3*G31*gamR3*G31'));
    
end

figure(1), ...
    subplot(1,3,1), plot(TM30,E,'b-',TM31,E,'r--','LineWidth',2), grid on, ...
        ylim([-4 4]), xlim([0 1.3]), legend(['t = 0 eV'],['t = 1 eV'],'Location',...
        'southeast'), ylabel('E (eV)'), xlabel('T(E)'), ...
        title('Serijska konfiguracija'), ...
    subplot(1,3,2), plot(TM20,E,'b-',TM21,E,'r--','LineWidth',2), grid on, ...
        ylim([-4 4]), xlim([0 1.3]), legend(['t = 0 eV'],['t = 1 eV'],'Location',...
        'southeast'), ylabel('E (eV)'), xlabel('T(E)'), title('T konfiguracija'), ...
    subplot(1,3,3), plot(TM10,E,'b-',TM11,E,'r--','LineWidth',2), grid on,...
        ylim([-4 4]), xlim([0 1.3]), legend(['t = 0 eV'],['t = 1 eV'],'Location',...
        'southeast'), ylabel('E (eV)'), xlabel('T(E)'), title('Paralelna konfiguracija');
