% parametri, SI jedinice osim energije (eV)
t1=1;
Gamma=1; g=-1i*Gamma/2;
zplus=1i*1e-12;
E=linspace(-8,8,2000);
Np=5; % dimenzija hamiltonijana

% matrice hamiltonijana
H1=-t1*diag(ones(1,Np-1),1)-t1*diag(ones(1,Np-1),-1);

% matrice vl. en. kontakata, prosirenja
L=diag([1 zeros(1,Np-1)]); R=diag([zeros(1,Np-1) 1]);
sigL1 = g*L; sigR1 = g*R;
gamL1=1i*(sigL1-sigL1'); gamR1=1i*(sigR1-sigR1');

TM1=zeros(1,length(E));
TM2=zeros(1,length(E));

for n=1:length(E)
    
    EE=E(n);
    
    % energijski ovisna m.vl.en. kontakata
    % za idealne kontakte potrebno racunati iznova na svakoj energiji
    ck=-(EE+zplus)/(2*t1); ka=acos(ck); sig=-t1*exp(1i*ka);
    sigL2 = sig*L; sigR2 = sig*R;
    gamL2=1i*(sigL2-sigL2'); gamR2=1i*(sigR2-sigR2');
    
    % Greenove funkcije
    G1=inv(((EE+zplus)*eye(Np))-H1-sigL1-sigR1);
    G2=inv(((EE+zplus)*eye(Np))-H1-sigL2-sigR2);
    % transmisija
    TM1(n)=real(trace(gamL1*G1*gamR1*G1'));
    TM2(n)=real(trace(gamL2*G2*gamR2*G2'));
        
end

figure(1), ...
    plot(TM1,E,'b-',TM2,E,'r--','LineWidth',2), grid on, ylim([-4 4]),...
        xlim([0 1.3]), legend(['\Sigma_{L,R} = -0,5*i'],...
        ['\Sigma_{L,R} = -t*exp(ika)'],'Location','northeast'),...
        ylabel('E (eV)'), xlabel('T(E)');



